#!/bin/bash

set -e 
set -o pipefail

# This is here for building the windows binary

wget https://www.libsdl.org/release/SDL2-devel-2.0.12-mingw.tar.gz -O /tmp/sdl.tar.gz

mkdir -p /tmp/sdl-extract

printf "extracting...\n"

# We want the library
tar -C /tmp/sdl-extract -xvzf /tmp/sdl.tar.gz SDL2-2.0.12/x86_64-w64-mingw32/lib

# and the DLL
tar -C /tmp/sdl-extract -xvzf /tmp/sdl.tar.gz SDL2-2.0.12/x86_64-w64-mingw32/bin/SDL2.dll

# and the headers just to be safe
tar -C /tmp/sdl-extract -xvzf /tmp/sdl.tar.gz SDL2-2.0.12/x86_64-w64-mingw32/include

printf "copying...\n"

# move them to where they belong
#cp -r /tmp/sdl-extract/SDL2-2.0.12/x86_64-w64-mingw32/* .

mv -n /tmp/sdl-extract/SDL2-2.0.12/x86_64-w64-mingw32/bin/SDL2.dll build/
mv -n /tmp/sdl-extract/SDL2-2.0.12/x86_64-w64-mingw32/lib/ src/sdllib
mv -n /tmp/sdl-extract/SDL2-2.0.12/x86_64-w64-mingw32/include/SDL2 src/

printf "Success.\n"
